/* Various defines for registers in the AVR */

/* General Interrupt Mask Register (GIMSK) */
#define		INT1		0x80		/* enable INT1 */
#define		INT0		0x40		/* enable INT0 */

/* The Timer/Counter Interrupt Mask Register (TIMSK) */
#define		TOIE1		0x80		/* Timer1 Overflow enable */
#define		OCE1A		0x40		/* Timer1 CompareA Match enable */
#define		OCE1B		0x20		/* Timer1 CompareB Match enable */
#define		TOIE0		0x02		/* Timer0 Overflow enable */

/* MCU Control Register (MCUCR) */
#define		SRE			0x80		/* Enable external SRAM */
#define		SRW			0x40		/* External SRAM wait enable */
#define		SE			0x20		/* Sleep Enable */
#define		SM			0x10		/* Sleep mode (0 = idle, 1 = power down) */

/* Timer0 and Timer1 prescalars */
#define		CK_STOP		0x00		/* Stop the timer */
#define		CK			0x01		/* CK */
#define		CK_8		0x02		/* CK/8 */
#define		CK_64		0x03		/* CK/64 */
#define 	CK_256		0x04		/* CK/256 */
#define		CK_1024		0x05		/* CK/1024 */

/* The Uart Control Register (UCR) */
#define		RXCIE		0x80		/* RX Complete Interrupt enable */
#define		TXCIE		0x40		/* TX Complete Interrupt enable */
#define		UDRIE		0x20		/* UDR empty interrupt enable */
#define		RXEN		0x10		/* RX enable */
#define		TXEN		0x08		/* TX enable */

/* Watchdog Timer Control */
#define		WDE			0x08		/* Watchdog enable */
#define		WD_16		0x00		/* 16 ms */
#define		WD_32		0x01		/* 32 ms */
#define		WD_64		0x02		/* 64 ms */
#define		WD_128		0x03		/* 128 ms */
#define		WD_256		0x04		/* 256 ms */
#define		WD_512		0x05		/* 512 ms */
#define		WD_1024		0x06		/* 1024 ms */
#define		WD_2048		0x07		/* 2048 ms */
