/*
	In this example the Watch Dog Timer (WDT) is set to a prescale of 2^21
(about 1 second with a 8Mhz 68HC11).  To reset the WDT you must use the
0x55AA sequence (see below).  To disable the WDT turn off bit 3 of OPTION.

Compile with:  CC11 wdt -pof
*/

#include <6811io.h>
#include <6811reg.h>

main()
{
	enable();
	
	for(;;) {
		/* little per-amble */
		printf("\nHit any key to reset WDT...");	
	
		/* set WDT */
		OPTION	 = 0x13;			/* enable WDT (prescale = 11) */

		/* wait for key */
		getch();

		/* reset WDT (sequence = 0x55AA) */
		COPRST = 0x55; COPRST = 0xAA;

		/* display sigh of relieve */
		printf("Whoa."); }
}