/* 68HC11 task swapper */

void add_task(unsigned func, int id, int *stack)
{
	*--stack = func;
	task_list[id] = stack-1;
}

void start(void) asm {
	LDX #task_list
	LDS ,X
}
	
/* perform swap */
void swap(void) asm
{
/* save current SP */
	LDD current_task    /* get current task number */
	ASLB                /* word entry */
	ADDD #task_list
	XGDX
	STS ,X              /* store stack address */

/* switch to new task */
	LDD current_task    /* current_task = (current_task + 1) % TASKS */
	ADDD #1
	CPD  #TASKS
	BEQ  change
	BRA  no_change
change
	LDD  #0
no_change
	STD current_task

	/* return to new task */
	ASLB                /* word entry */
	ADDD #task_list
	XGDX				/* X = pointer to entry */
	LDS ,X              /* SP */
}
