/* 68HC12 task swapper */

void add_task(void *func, int id, int *stack)
{
	*--stack = func;
	task_list[id] = stack;
}

void start(void) asm
{
	LDX #task_list
	LDS ,X
}

/* perform swap (requires about 39 cycles) */
void swap(void) asm
{
/* save current SP */
	LDD current_task    /* get current task number */
	ASLB                /* word entry */
	ADDD #task_list
	TFR D,X
	STS ,X              /* store stack address */

/* switch to new task */
	LDD current_task    /* current_task = (current_task + 1) % TASKS */
	ADDD #1
	CPD  #TASKS
	BEQ  change
	BRA  no_change
change
	LDD  #0
no_change
	STD current_task

	/* return to new task */
	ASLB                /* word entry */
	ADDD #task_list
	TFR D,X             /* X = pointer to entry */
	LDS ,X              /* SP */
	
	RTS
}
