/* Task swapper for 8096 */

/* put function on list */
void add_task(void *func, int id, int *stack)
{
	*--stack = func;
	*--stack = 0;				/* fake BP value */
	task_list[id] = stack;
}

void start(void) asm 
{
	LD SP,task_list
}

void swap(void) asm {
	/* save SP in list */	
	LD BX,current_task
	SHL BX,#1
	ADD BX,#task_list
	ST SP,[BX]							/* save SP */

	LD BX,current_task
	INC BX
	CMP BX,#TASKS
	JNE no_change

	XOR BX,BX							/* restart to first task */
no_change:
	ST BX,current_task
	
	/* jump to new task */
	SHL BX,#1
	ADD BX,#task_list
	LD SP,[BX]							/* get new SP */

	/* restore (Micro-C does this for us :) )  */
}

